#
# spec file for package net-snmp-5.4-snapshot
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#
# norootforbuild
%define netsnmp_logfile /var/log/net-snmpd.log
%define netsnmp_agentxsocketdir /var/run/agentx
%define netsnmp_persistentdir /var/lib/net-snmp
#
Name:           net-snmp-5.4-snapshot
#                         datetime in UTC
Version:        5.4.x.svn201106250230
Release:        1.1
#
Group:          Productivity/Networking/Other
License:        Other License(s), see package
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  openssl-devel rpm-devel sensors tcpd-devel
%if 0%{?suse_version} > 1030
BuildRequires:  libsensors3-devel
%endif
#
Provides:       snmp ucdsnmp
Obsoletes:      snmp ucdsnmp
PreReq:         %insserv_prereq %fillup_prereq /sbin/chkconfig
Requires:       perl-TermReadKey logrotate
#
URL:            http://www.net-snmp.org/
# cvs -z8 -d:pserver:anonymous@net-snmp.cvs.sourceforge.net:/cvsroot/net-snmp co net-snmp
Source:         net-snmp.tar.gz
Source1:        net-snmp.init
Source2:        net-snmp.logrotate
Source3:        net-snmp.sysconfig
Source4:        snmpd.conf
Source5:        README.SuSE
Source6:        snmptrapd.init
Source7:        test_installed
Patch:          net-snmp-5.1.1-pie.patch
Patch1:         net-snmp-5.3_vendorperl.patch
#
Summary:        SNMP Daemon
%description
This package was originally based on the CMU 2.1.2.1 snmp code. It has
been greatly modified, restructured, enhanced, and fixed. It hardly
looks the same as anything that CMU has ever released. It was renamed
from cmu-snmp to ucd-snmp in 1995 and later renamed from ucd-snmp to
net-snmp in November 2000.



Authors:
--------
    Wes Hardaker <hardaker@users.sourceforge.net>

%package devel
Summary:        SNMP Daemon
Group:          Productivity/Networking/Other
Requires:       %{name} = %{version}
Requires:       openssl-devel rpm-devel sensors tcpd-devel

%description devel
This package was originally based on the CMU 2.1.2.1 snmp code. It has
been greatly modified, restructured, enhanced, and fixed. It hardly
looks the same as anything that CMU has ever released. It was renamed
from cmu-snmp to ucd-snmp in 1995 and later renamed from ucd-snmp to
net-snmp in November 2000.



Authors:
--------
    Wes Hardaker <hardaker@users.sourceforge.net>

%package -n perl-SNMP-5.4-snapshot
Summary:        Perl-SNMP
Group:          Development/Libraries/Perl
Requires:       %{name} = %{version}

%description -n perl-SNMP-5.4-snapshot
Perl5 Modules for the Net-SNMP library.



Authors:
--------
    G.S. Marzot <gmarzot@nortelnetworks.com>

%prep
%setup -n net-snmp
%patch
%patch1
find -name "CVS" -type d | xargs -r %{__rm} -rfv
find -name ".cvsignore"  | xargs -r %{__rm} -fv
find -name "*.orig"      | xargs -r %{__rm} -fv

%build
#autoconf
# possibly add later
# ip-mib/ipv4InterfaceTable ip-mib/ipv6InterfaceTable
export CFLAGS="%{optflags} -fno-strict-aliasing"
%if 0%{?suse_version} > 1000
export CFLAGS="$CFLAGS -fstack-protector-all"
%endif
%configure \
	--with-sys-contact="root@localhost" \
	--with-mib-modules="misc/ipfwacc smux ucd-snmp/diskio ucd-snmp/lmSensors" \
	--with-persistent-directory=%{netsnmp_persistentdir} \
	--with-agentx-socket=%{netsnmp_agentxsocketdir}/master \
	--with-sys-location="unknown" \
	--with-logfile=%{netsnmp_logfile} \
	--with-libwrap=%{_prefix} \
	--with-defaults \
	--enable-shared \
	--enable-as-needed \
	--disable-static \
	--without-root-access \
	--enable-local-smux \
	--enable-ipv6 \
	--enable-ucd-snmp-compatibility \
	--enable-embedded-perl
%{__make} all
%ifnarch %arm
# allow for better debugging of failed tests
ulimit -c unlimited
# UDP tests
%{__make} test || { { find /tmp/snmp-test-* -type f -ls; for f in $(find /tmp/snmp-test-* -type f ! -name core\* -print); do echo "== $f (udp test) =="; cat $f; done } ||: ; exit 1 ; }
# TCP tests
%{__make} test TESTOPTS='-P tcp' || { { find /tmp/snmp-test-* -type f -ls; for f in $(find /tmp/snmp-test-* -type f ! -name core\* -print); do echo "== $f (tcp test) =="; cat $f; done } ||: ; exit 1 ; }
%endif
%{__make} perlmodules
# not yet safe to be run in parallel, so ignore errors for the moment
LD_RUN_PATH="$PWD/snmplib/.libs" LD_LIBRARY_PATH="${PWD}/snmplib/.libs:${PWD}/agent/.libs:${PWD}/agent/helpers/.libs" %{__make} perltest || true

%install
%makeinstall INSTALL_PREFIX=%{buildroot}
%{__rm} -f %{buildroot}/%{perl_vendorarch}/Bundle/Makefile.subs.pl
%perl_process_packlist
#
%{__install} -d \
    %{buildroot}/var/log \
    %{buildroot}%{netsnmp_persistentdir} \
    %{buildroot}/usr/lib/net-snmp/agents \
    %{buildroot}%{netsnmp_agentxsocketdir}
#
%{__install} -D -m 0755 %{S:1} %{buildroot}/etc/init.d/snmpd
%{__ln_s} -f /etc/init.d/snmpd %{buildroot}%{_sbindir}/rcsnmpd
#
%{__install} -D -m 0644 %{S:2} %{buildroot}/etc/logrotate.d/net-snmp
%{__install} -D -m 0600 %{S:4} %{buildroot}/etc/snmp/snmpd.conf
%{__install} -D -m 0644 %{S:3} %{buildroot}/var/adm/fillup-templates/sysconfig.net-snmp
#
%{__install} -m 0644 %{S:5} %{S:6} .
%{__install} -m 0744 %{S:7} testing/
#
touch %{buildroot}/var/log/net-snmpd.log

%clean
%{__rm} -rf %{buildroot}

%preun
%stop_on_removal snmpd

%post
# if we are upgrading from older distros the config should be moved
# to the new place
CONFD="/etc/snmp"
OCONF="/etc/snmpd.conf"
NCONF="${CONFD}/snmpd.conf"
NCONFB="${CONFD}/snmpd.conf.rpmsave"
if [ -e "$OCONF" ] ; then
#
# in worst case we will get:
# /etc/snmp/snmpd.conf         - the old /etc/snmpd.conf
# /etc/snmp/snmpd.conf.rpmnew  - the config of the newly installed package.
# /etc/snmp/snmpd.conf.rpmsave - the old /etc/snmp/snmpd.conf
#
    if [ ! -d "$CONFD" ] ; then 
        mkdir "$CONFD"
    fi
#
# we dont need to handle the case that /etc/snmp/snmpd.conf
# exists. rpm does that for us.
# it creates /etc/snmp/snmpd.conf.rpmnew
#
    if [ -e "$NCONF" ] ; then
        mv "$NCONF" "$NCONFB"
        echo "warning: /etc/snmp/snmpd.conf backed up as /etc/snmp/snmpd.conf.rpmsave" >&2
    fi
    echo "warning: /etc/snmpd.conf moved to /etc/snmp/snmpd.conf" >&2
    mv "$OCONF" "$NCONF"
fi
# we might be updating from ucdsnmp soon
/sbin/chkconfig -c snmpd 2> /dev/null && FIRST_ARG=2
%{fillup_and_insserv snmpd}

%postun
%restart_on_update snmpd
%{insserv_cleanup}

%files
%defattr(-,root,root)
%doc AGENT.txt COPYING EXAMPLE.conf EXAMPLE.conf.def
%doc README* FAQ NEWS TODO snmptrapd.init
%dir /etc/snmp
%config(noreplace) /etc/snmp/snmpd.conf
%config /etc/init.d/snmpd
%{_bindir}/encode_keychange
%{_bindir}/fixproc
%{_bindir}/ipf-mod.pl
%{_bindir}/net-snmp-config
%{_bindir}/snmpbulkget
%{_bindir}/snmpbulkwalk
%{_bindir}/snmpcheck
%{_bindir}/snmpconf
%{_bindir}/snmpdelta
%{_bindir}/snmpdf
%{_bindir}/snmpget
%{_bindir}/snmpgetnext
%{_bindir}/snmpinform
%{_bindir}/snmpnetstat
%{_bindir}/snmpset
%{_bindir}/snmpstatus
%{_bindir}/snmptable
%{_bindir}/snmptest
%{_bindir}/snmptranslate
%{_bindir}/snmptrap
%{_bindir}/snmpusm
%{_bindir}/snmpvacm
%{_bindir}/snmpwalk
%{_bindir}/traptoemail
%dir %{_prefix}/lib/net-snmp
%dir %{_prefix}/lib/net-snmp/agents
%{_libdir}/libsnmp*.so.*
%{_libdir}/libnetsnmp*.so.*
%{_mandir}/man[158]/*
%{_sbindir}/*
%{_datadir}/snmp
%{netsnmp_persistentdir}
%dir %attr(700,root,root) %{netsnmp_agentxsocketdir}
%ghost %{netsnmp_logfile}
%config(noreplace) /etc/logrotate.d/net-snmp
/var/adm/fillup-templates/sysconfig.net-snmp

%files devel
%defattr(-,root,root)
%doc ChangeLog PORTING testing
%{_mandir}/man3/*
%{_includedir}/ucd-snmp
%{_includedir}/net-snmp
%{_libdir}/libsnmp*.*a
%{_libdir}/libsnmp*.so
%{_libdir}/libnetsnmp*.*a
%{_libdir}/libnetsnmp*.so

%files -n perl-SNMP-5.4-snapshot
%defattr(-,root,root)
%{perl_vendorarch}/auto/SNMP
%{perl_vendorarch}/auto/NetSNMP
%{perl_vendorarch}/auto/Bundle
%{perl_vendorarch}/SNMP.pm
%{perl_vendorarch}/NetSNMP
/var/adm/perl-modules/%{name}
%{_bindir}/tkmib
%{_bindir}/mib2c
%{_bindir}/mib2c-update
